
/** 
***************************************************
Asignatura: Tecnologías Web
Titulación: GIITIN
Autor     : Enrique
Universidad de Oviedo
***************************************************
**/
//Código de operacion (Alta o Edicion)
var operation = "A"; 
//Indice del elemento seleccionado
var selected_index = -1;
//Recuperamos la tabla de alumnos anterior (si la hubiere)
var tbAlumnos = localStorage.getItem("tbAlumnos");
//La parseamos a formato Objeto
tbAlumnos = JSON.parse(tbAlumnos); //Converts string to object
//Sino no existiera previamente la tabla, se inicia a un array vacio.
if(tbAlumnos == null) 
	tbAlumnos = [];

//Alta de un nuevo alumno
function Add(){
	//Preparamos el registro de un alumno
	var alumno = JSON.stringify({
		ID        : document.getElementById("txtID").value,
		IDUser    : document.getElementById("txtIDUser").value,
		Nombre    : document.getElementById("txtNombre").value,
		Apellidos : document.getElementById("txtApellidos").value,
		Email     : document.getElementById("txtEmail").value,
		Ciudad     : document.getElementById("txtCiudad").value,
		Direccion     : document.getElementById("txtDireccion").value
	});
	//Añadimos al almacenamiento Web un alumno
	tbAlumnos.push(alumno);
	//Reescribimos la variable "tbAlumnos" del almacenamiento web.
	localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
	//Mostramos un mensaje de confirmación del alta de alumno
	alert("Alumno dado de alta.");
	//Añadimos un nuevo elemento a la tabla
	List();

}

function Edit(){
	//Preparamos el registro de un alumno
	tbAlumnos[selected_index] = JSON.stringify({
		ID        : document.getElementById("txtID").value,
		IDUser    : document.getElementById("txtIDUser").value,
		Nombre    : document.getElementById("txtNombre").value,
		Apellidos : document.getElementById("txtApellidos").value,
		Email     : document.getElementById("txtEmail").value,
		Ciudad     : document.getElementById("txtCiudad").value,
		Direccion     : document.getElementById("txtDireccion").value
	});//Se sobreescribe el elemento a editado sobre la table "tbAlumnos"
	//Reescribimos la variable "tbAlumnos" del almacenamiento web.
	localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
	alert("Alumno modificado.");
	operation = "A"; //Se retorna el valor por defecto
	//Visualizamos el elemento editado en la tabla
	List();

}

//Eliminación de un alumno existente
function Delete(){
	//se elimina la posición del alumno a eliminar (selected_index)
	tbAlumnos.splice(selected_index, 1);
	//Reescribimos la variable "tbAlumnos" del almacenamiento web.
	localStorage.setItem("tbAlumnos", JSON.stringify(tbAlumnos));
	alert("Alumno eliminado.");
}

//Lista de alumnos
function List(){	
	var tabla = document.getElementById("tblList");
	//Añadimo la cabecera y el cuerpo vacio
	tabla.innerHTML="<thead>"+
	"	<tr>"+
	"	<th></th>"+
	"	<th>ID</th>"+
	"	<th>IDUser</th>"+
	"	<th>Nombre</th>"+
	"	<th>Apellidos</th>"+
	"	<th>Email</th>"+
	"	<th>Ciudad</th>"+
	"	<th>Direccion</th>"+
	"	</tr>"+
	"</thead>"+
	"<tbody>"+
	"</tbody>";
	//Rellenamos el cuerpo	
	var cuerpo = tabla.tBodies[0];
	var cuerpoHTML = "";
	for(var i in tbAlumnos){
		var alumno = JSON.parse(tbAlumnos[i]);
		//Añadirmos una fila por alumno
		cuerpoHTML = cuerpoHTML + "<tr>"+
		"	<td><img src='icons/edit.png' alt='Editar"+i+"' onclick='btnEdit(event)''/><img src='icons/delete.png' alt='Borrar"+i+"' onclick='btnDelete(event)''/></td>" + 
		"	<td>"+alumno.ID+"</td>" + 
		"	<td>"+alumno.IDUser+"</td>" + 
		"	<td>"+alumno.Nombre+"</td>" + 
		"	<td>"+alumno.Apellidos+"</td>" + 
		"	<td>"+alumno.Email+"</td>" + 
		"	<td>"+alumno.Ciudad+"</td>" + 
		"	<td>"+alumno.Direccion+"</td>" + 
		"</tr>";
	}
	cuerpo.innerHTML = cuerpoHTML;

}

// MANEJADORES DE EVENTOS
function Inicializar()
{
	//Listamos los alumnos existentes
	List();
}
// Gestion boton formulario
function botonFormulario() {
	if(operation == "A")
		return Add();
	else
		return Edit();
}
//Gestion de enlace de edición
function btnEdit(evento)
{
	//Ponemos el estado de operacion 'E' para que al salvar el formulario 
	//de alta/edición se considere la operación edición
	operation = "E";
	//Obtenemos el ID del alumno del atributo "alt" correspondiente al botón/imagen "Editar"
	//para ello reemplazamos el texto "Editar" por "", quedando sólo el número.
	selected_index = parseInt(evento.target.alt.replace("Editar", ""));
	//Obtenemos los datos del alumnos del array tbAlumnos
	var alumno = JSON.parse(tbAlumnos[selected_index]);
	//Pintamos los datos alumnos sobre el formularios de alta/edición
	document.getElementById("txtID").value = alumno.ID;
	document.getElementById("txtIDUser").value = alumno.IDUser;
	document.getElementById("txtNombre").value = alumno.Nombre,
	document.getElementById("txtApellidos").value = alumno.Apellidos,
	document.getElementById("txtEmail").value = alumno.Email;
	document.getElementById("txtCiudad").value = alumno.Ciudad,
	document.getElementById("txtDireccion").value = alumno.Direccion;

	document.getElementById("txtID").readOnly = true;   //Esta propiedad es de solo lectura
	document.getElementById("txtNombre").focus();                   //Ponemos el foco en el campo Nombre.
}

//Gestión de enlace de borrado
//Manejador del evento onclick del enlace btnDelete
function btnDelete(evento){
	//Obtenemos el ID del alumno del atributo "alt" correspondiente al botón/imagen "Borrar"
	//para ello reemplazamos el texto "Borrar" por "", quedando sólo el número.
	selected_index = parseInt(evento.target.alt.replace("Borrar", ""));
	//Borramos el alumno seleccionado sobre el icono de borrado
	Delete();
	//Volvemos a listar los alumnos restantes para que desaparezca el eliminado
	List();
	//Vamos a borrar la fila
	//$(this).parent().parent().remove();
}

